/*1:*/
#line 74 "analysis.w"

#define REVDATE "4th February 2002"

/*:1*//*23:*/
#line 677 "analysis.w"


/*26:*/
#line 878 "analysis.w"


#include "config.h"         


#include <iostream> 
#include <exception> 
#include <stdexcept> 
#include <string> 
using namespace std;

#include <stdio.h> 
#include <stdlib.h> 
#include <ctype.h> 
#ifdef HAVE_GETOPT
#ifdef HAVE_UNISTD_H
#include <unistd.h> 
#endif
#else
#include "getopt.h"     
#endif
#include "analysis.h"        


/*:26*/
#line 679 "analysis.w"
;

/*25:*/
#line 860 "analysis.w"

static void usage(void)
{
cout<<PRODUCT<<"  --  Analyse eggsummary files.  Call:\n";
cout<<"              "<<PRODUCT<<" [options] [infile] [outfile]\n";
cout<<"\n";
cout<<"Options:\n";
cout<<"           --copyright       Print copyright information\n";
cout<<"           -u, --help        Print this message\n";
cout<<"           --version         Print version number\n";
cout<<"\n";
cout<<"by John Walker\n";
cout<<"http://www.fourmilab.ch/\n";
}

/*:25*/
#line 681 "analysis.w"
;

int main(int argc,char*argv[])
{
extern char*optarg;
extern int optind;

try{

int opt;

/*24:*/
#line 828 "analysis.w"

while((opt= getopt(argc,argv,"nu-:"))!=-1){
switch(opt){

case'u':
case'?':
usage();
return 0;

case'-':
switch(optarg[0]){
case'c':
cout<<"This program is in the public domain.\n";
return 0;

case'h':
usage();
return 0;

case'v':
cout<<PRODUCT<<" "<<VERSION<<"\n";
cout<<"Last revised: "<<REVDATE<<"\n";
cout<<"The latest version is always available\n";
cout<<"at http://www.fourmilab.ch/eggtools/eggshell\n";
return 0;
}
}
}

/*:24*/
#line 692 "analysis.w"
;


#if 0

{int j;

eggdatabases ed;
ed.set_Fourmilab_defaults();

#ifndef CACHE_TEST
#define DEFAULT_EGGANALYSIS
#ifdef DEFAULT_EGGANALYSIS
generic_eggsummary_cache<egganalysis> ec(&ed,"rotten_egg.csv",50,150);
egganalysis*esr;
egganalysis ext;
#else
typedef generic_egganalysis<double> double_egganalysis;
generic_eggsummary_cache<double_egganalysis> ec(&ed,"rotten_egg.csv",50,150);
double_egganalysis*esr;
double_egganalysis ext;
#endif

esr= ec.get_by_date("2001-04-22");
systemtime refstart;


#ifndef EXTRACT_TEST
systemtime exstart,exend;

exstart.fromString("2001-04-22 13:00:00");
exend.fromString("2001-04-22 22:30:00");
esr->extract_time_range(&ext,exstart,exend);
esr= &ext;
#endif
esr->compute_per_egg_statistics();
esr->describe();
esr->write_per_egg_statistics_CSV("peregg.csv");
esr->write_deviation_plot("devtest",
"",
systemtime::SecondsPerHour,
systemtime::SecondsPerHour*8,
"",
0.05,
refstart
);
#else 
egganalysis esr;
systemtime t;
t.fromString("2001-04-22");

esr.load_from_CSV(ed.database_file(t));

esr.exclude_bad_data("rotten_egg.csv");
esr.limit_to_range(50,150,&cout);
esr.compute_all_egg_statistics();

#if 0
for(j= 0;j<esr.eggs_reporting;j++){
cout<<esr.egg_number[j]<<": "<<(int)esr.get_egg_index(86399,j)<<"\n";
}
#endif

#if 0 
esr.write_egg_statistics_CSV("test_24.csv");
#endif

#ifndef SIMPLE
esr.write_deviation_plot("devtest",
"",
systemtime::SecondsPerHour,
systemtime::SecondsPerHour*8,
"",
0.05
);
#else
esr.write_deviation_plot("devtest",
"Earth Day: 2001 April 22",
systemtime::SecondsPerHour
);
#endif
#endif
}
#endif

#if 1

{

eggdatabases ed;
ed.set_Fourmilab_defaults();
generic_eggsummary_cache<egganalysis> ec(&ed,"rotten_egg.csv",50,150);
egganalysis ext;

systemtime refstart;
systemtime exstart,exend;

exstart.fromString("2001-04-20 13:00:00");
exend.fromString("2001-04-24 22:30:00");
ec.extract_time_range(&ext,exstart,exend);
ext.compute_per_egg_statistics();
ext.describe();
ext.write_per_egg_statistics_CSV("peregg.csv");
ext.write_deviation_plot("devtest",
"",
systemtime::SecondsPerHour,
systemtime::SecondsPerHour*8,
"",
0.05,
refstart
);
}
#endif


}catch(exception&e){
cout<<"Blooie!!!  Exception popped: "<<e.what()<<endl;
#ifndef CORE_DUMP
#ifdef STACK_TRACE
char s[160];
sprintf(s,"/bin/echo 'where\nq' >/tmp/gdbcmd ; gdb  -batch --command "
"/tmp/gdbcmd %s %d",argv[0],getpid());
system(s);
sleep(5);
#endif
throw;
#endif
}

return 0;
}

/*:23*/
