/*2:*/
#line 51 "eggshell.w"

#include "config.h"                   

#define REVDATE "27th May 2001" \


#line 54 "eggshell.w"


/*3:*/
#line 66 "eggshell.w"



#include <iostream> 
#include <fstream> 
#include <exception> 
#include <stdexcept> 
#include <string> 
#include <vector> 
#include <map> 
using namespace std;

#include <stdio.h> 
#include <stdlib.h> 
#include <ctype.h> 
#include <time.h> 
#include <math.h> 
#include <assert.h> 
#ifdef HAVE_STRING_H
#include <string.h> 
#else
#ifdef HAVE_STRINGS_H
#include <strings.h> 
#endif
#endif
#ifdef HAVE_GETOPT
#ifdef HAVE_UNISTD_H
#include <unistd.h> 
#endif
#else
#include "getopt.h"     
#endif

/*:3*/
#line 56 "eggshell.w"

/*4:*/
#line 103 "eggshell.w"

#include "statlib.h"        
#include "timedate.h"       
#include "eggdata.h"        

/*:4*/
#line 57 "eggshell.w"

/*5:*/
#line 112 "eggshell.w"

typedef unsigned char byte;

static FILE*fi;
static FILE*fo;
static bool errcheck= true;

/*:5*/
#line 58 "eggshell.w"

/*6:*/
#line 123 "eggshell.w"


/*:6*/
#line 59 "eggshell.w"


/*:2*//*8:*/
#line 130 "eggshell.w"


static void usage(void)
{
cout<<PRODUCT<<"  --  Analyse eggsummary files.  Call:\n";
cout<<"              "<<PRODUCT<<" [options] [infile] [outfile]\n";
cout<<"\n";
cout<<"Options:\n";
cout<<"           --copyright       Print copyright information\n";
cout<<"           -n, --noerrcheck  Ignore errors\n";
cout<<"           -u, --help        Print this message\n";
cout<<"           --version         Print version number\n";
cout<<"\n";
cout<<"by John Walker\n";
cout<<"http://www.fourmilab.ch/\n";
}

/*:8*//*9:*/
#line 149 "eggshell.w"


int main(int argc,char*argv[])
{
extern char*optarg;
extern int optind;

try{

int f,opt;
char*cp;

fi= stdin;
fo= stdout;

/*10:*/
#line 336 "eggshell.w"

while((opt= getopt(argc,argv,"nu-:"))!=-1){
switch(opt){
case'n':
errcheck= false;
break;

case'u':
case'?':
usage();
return 0;

case'-':
switch(optarg[0]){
case'c':
cout<<"This program is in the public domain.\n";
return 0;

case'h':
usage();
return 0;

case'n':
errcheck= false;
break;

case'v':
cout<<PRODUCT<<" "<<VERSION<<"\n";
cout<<"Last revised: "<<REVDATE<<"\n";
cout<<"The latest version is always available\n";
cout<<"at http://www.fourmilab.ch/eggtools/eggshell\n";
return 0;
}
}
}

/*:10*/
#line 164 "eggshell.w"
;
/*11:*/
#line 377 "eggshell.w"

f= 0;
for(;optind<argc;optind++){
cp= argv[optind];
switch(f){

case 0:
if(strcmp(cp,"-")!=0){
if((fi= fopen(cp,"r"))==NULL){
cerr<<"Cannot open input file "<<cp<<"\n";
return 2;
}
}
f++;
break;

case 1:
if(strcmp(cp,"-")!=0){
if((fo= fopen(cp,"w"))==NULL){
cerr<<"Cannot open output file "<<cp<<"\n";
return 2;
}
}
f++;
break;

default:
cerr<<"Too many file names specified.\n";
usage();
return 2;
}
}

/*:11*/
#line 165 "eggshell.w"
;

string s;
systemtime td,td1;

td.now();
cout<<td.dateToString()<<" "<<td.timeToString()<<"\n";
td1= td;
td1.nextDay();
cout<<"Tomorrow: "<<td1.dateToString()<<" "<<td1.timeToString()<<"\n";
td1= td;
td1.previousDay();
cout<<"Yesterday: "<<td1.dateToString()<<" "<<td1.timeToString()<<"\n";
td1= td;
td1.dayStep(7);
cout<<"Next week: "<<td1.dateToString()<<" "<<td1.timeToString()<<"\n";

td.fromString("1981-04-12 13:51:18");
cout<<td.dateToString()<<" "<<td.timeToString()<<"\n";
td.fromString("2021-04-12");
cout<<td.dateToString()<<" "<<td.timeToString()<<"\n";
cout<<"Weekday = "<<systemtime::jwday(systemtime::utctoj(2001,
5,12,23,59,59))<<"\n";
td.fromJulian(2436116.31);
cout<<td.dateToString()<<" "<<td.timeToString()<<"\n";
cout<<"To Julian = "<<td.toJulian()<<" Weekday = "<<td.weekday()<<"\n";
td.fromString("1987-04-10");
cout<<"Sidereal time = "<<td.siderealTime()<<"\n";
cout.flush();
int t1,t2,t3;
systemtime::jyear(2436116.31,&t1,&t2,&t3);
printf("%04d-%02d-%02d\n",t1,t2,t3);
systemtime::jhms(systemtime::utctoj(1989,11,14,16,23,18),&t1,&t2,&t3);
printf("%02d:%02d:%02d\n",t1,t2,t3);

eggdatabases edb;

cout<<"Pathname for GCP is "<<edb.path("gcp")<<"\n";

#if 0
td.fromString("Bob");
cout<<td.dateToString()<<" "<<td.timeToString()<<"\n";
#endif



{
normalDistribution nd(100,7.07);

cout<<"Normal dist: mu = "<<nd.get_mu()<<" sigma = "<<
nd.get_sigma()<<" variance = "<<nd.variance()<<"\n";
cout<<"  P = "<<nd.CDF_P(110)<<" Q = "<<nd.CDF_Q(110)<<"\n";
nd.writeParameters(cout);

nd.approximateBinomial(200);
cout<<"Normal dist: mu = "<<nd.get_mu()<<" sigma = "<<
nd.get_sigma()<<" variance = "<<nd.variance()<<"\n";
cout<<"  P = "<<nd.CDF_P(110)<<" Q = "<<nd.CDF_Q(110)<<
"  z = "<<nd.z_score(110)<<"\n";
}


{
chiSquareDistribution xd(32);

xd.writeParameters(cout);
cout<<"Chi-square dist: k = "<<xd.get_k()<<"\n";
cout<<"  P = "<<xd.CDF_P(36)<<" Q = "<<xd.CDF_Q(36)<<"\n";
}

{
binomialDistribution bd(200,0.5);

cout<<"Binomial dist: n = "<<bd.get_n()<<" r = "<<
bd.get_r()<<" variance = "<<bd.variance()<<"\n";
cout<<"  P = "<<bd.CDF_P(110)<<" Q = "<<bd.CDF_Q(110)<<
"  z = "<<bd.z_score(110)<<"\n";
bd.writeParameters(cout);
}
cout.flush();

#if 0

eggsummary es;

#if 0
ifstream ci("../test.csv");
es.load_from_CSV(ci);
ci.close();
#endif
es.load_from_CSV("../test.csv.gz");

for(int j= 0;j<es.eggs_reporting;j++){
cout<<es.egg_number[j]<<": "<<(int)es.get_egg_index(86399,j)<<"\n";
}
#endif

#if 1

{int j;

eggsummary*es;
eggsummary_cache ec;

es= ec.get("../test.csv.gz");
eggsummary&esr= *es;

for(j= 0;j<esr.eggs_reporting;j++){
cout<<esr.egg_number[j]<<": "<<(int)esr.get_egg_index(86399,j)<<"\n";
}


es= ec.get("../test.csv.gz");
esr= *es;


for(j= 55860;j<(55860+60);j++){
cout<<(j-55860)<<" = "<<((int)esr.get_egg_number(j,37))<<" "<<
(esr.isSampleValid(j,37)?"":"(Bad)")<<endl;
}

esr.exclude_bad_data("rotten_egg.csv");

esr.limit_to_range(70,130,&cout);

for(j= 0;j<esr.eggs_reporting;j++){
cout<<esr.egg_number[j]<<": "<<(int)esr.get_egg_index(86399,j)<<"\n";
}

for(j= 55860;j<(55860+60);j++){
cout<<(j-55860)<<" = "<<((int)esr.get_egg_number(j,37))<<" "<<
(esr.isSampleValid(j,37)?"":"(Bad)")<<endl;
}
}
#endif

#if 0

while((cout<<"--> "),getline(cin,s)){
csv_parser p(s);
string f;

cout<<s;
cout<<"\n";

while(p.next_field(f)){
cout<<"{"+f+"}\n";
}
}
#endif
}catch(exception&e){
cout<<"Blooie!!!  Exception popped: "<<e.what()<<endl;
#ifndef CORE_DUMP
#ifdef STACK_TRACE
char s[160];
sprintf(s,"/bin/echo 'where\nq' >/tmp/gdbcmd ; gdb  -batch --command "
"/tmp/gdbcmd %s %d",argv[0],getpid());
system(s);
sleep(5);
#endif
throw;
#endif
}

return 0;
}

/*:9*/
