/*23:*/
#line 515 "examples.w"

/*47:*/
#line 964 "examples.w"


/*51:*/
#line 1061 "examples.w"


#include "config.h"         
#define REVDATE "22nd February 2002" \

#define EGGS_CSV "eggs.csv"
#define ROTTEN_CSV "rotten_egg.csv" \


#line 1064 "examples.w"


#include "analysis.h"       
#include "fourier.h"     

#include <stdio.h> 
#include <stdlib.h> 
#ifdef HAVE_GETOPT
#ifdef HAVE_UNISTD_H
#include <unistd.h> 
#endif
#else
#include "getopt.h"     
#endif

/*:51*/
#line 966 "examples.w"
;

/*50:*/
#line 1040 "examples.w"

static void usage(void)
{
cout<<PRODUCT<<"  --  Analyse eggsummary files.  Call:\n";
cout<<"              "<<PRODUCT<<" [options] [infile] [outfile]\n";
cout<<"\n";
cout<<"Options:\n";
cout<<"           --copyright       Print copyright information\n";
cout<<"           -u, --help        Print this message\n";
cout<<"           --version         Print version number\n";
cout<<"\n";
cout<<"by John Walker\n";
cout<<"http://www.fourmilab.ch/\n";
}

/*:50*/
#line 968 "examples.w"
;

int main(int argc,char*argv[])
{
extern char*optarg;
extern int optind;

try{

/*49:*/
#line 1006 "examples.w"

int opt;

while((opt= getopt(argc,argv,"nu-:"))!=-1){
switch(opt){

case'u':
case'?':
usage();
return 0;

case'-':
switch(optarg[0]){
case'c':
cout<<"This program is in the public domain.\n";
return 0;

case'h':
usage();
return 0;

case'v':
cout<<PRODUCT<<" "<<VERSION<<"\n";
cout<<"Last revised: "<<REVDATE<<"\n";
cout<<"The latest version is always available\n";
cout<<"at http://www.fourmilab.ch/eggtools/eggshell\n";
return 0;
}
}
}

/*:49*/
#line 977 "examples.w"
;

/*:47*/
#line 516 "examples.w"
;

eggdatabases ed;
ed.set_local_defaults();
generic_eggsummary_cache<egganalysis> ec(&ed,ROTTEN_CSV,50,150);
egg_properties_database epd;
epd.loadFromCSV(EGGS_CSV);

/*:23*//*24:*/
#line 531 "examples.w"

egganalysis ext;
ec.extract_time_range(&ext,systemtime("2001-12-30 00:00:00"),
systemtime("2002-01-01 23:59:59"));

/*:24*//*25:*/
#line 543 "examples.w"

int i;
map<unsigned int,int> offset;
for(i= 0;i<ext.eggs_reporting;i++){
egg_properties*ep= epd.find(ext.egg_number[i]);
assert(ep!=NULL);
double zlon= ep->longitude-((360/24)/2.0);
double alon= fabs(zlon);
int atz= (int)(alon/(360/24));
int tz= (zlon<0)?(-atz):atz;
offset.insert(make_pair(ep->eggNumber,tz*systemtime::SecondsPerHour));
#if 0
cout<<ep->eggNumber<<"  "<<ep->longitude<<"  "<<tz<<
"  "<<offset.find(ep->eggNumber)->second<<endl;
#endif
}

/*:25*//*26:*/
#line 580 "examples.w"

for(i= 0;i<ext.eggs_reporting;i++){
if(offset.find(ext.egg_number[i])->second!=0){
#if 0
cout<<"Shifting egg "<<ext.egg_number[i]<<" by "<<(-offset.find(ext.egg_number[i])->second)<<" seconds."<<endl;
#endif
ext.time_shift(ext.egg_number_to_index(ext.egg_number[i]),
-(offset.find(ext.egg_number[i])->second));
}
}

/*:26*//*27:*/
#line 603 "examples.w"



egganalysis exa;
ext.extract_time_range(&exa,systemtime("2001-12-31 21:00:00"),
systemtime("2002-01-01 03:00:00"));

/*:27*//*28:*/
#line 613 "examples.w"

exa.write_deviation_plot("example-6",
"",
systemtime::SecondsPerHour,
-3*systemtime::SecondsPerHour,
"Hours from Midnight, Local Time",
0.05
);

/*48:*/
#line 983 "examples.w"

}catch(exception&e){
cout<<"Blooie!!!  Exception popped: "<<e.what()<<endl;
#ifndef CORE_DUMP
#ifdef STACK_TRACE
char s[160];
sprintf(s,"/bin/echo 'where\nq' >/tmp/gdbcmd ; gdb  -batch --command "
"/tmp/gdbcmd %s %d",argv[0],getpid());
system(s);
sleep(5);
#endif
throw;
#endif
}

return 0;
}


/*:48*/
#line 622 "examples.w"
;

/*:28*/
