/*29:*/
#line 636 "examples.w"

/*47:*/
#line 964 "examples.w"


/*51:*/
#line 1061 "examples.w"


#include "config.h"         
#define REVDATE "22nd February 2002" \

#define EGGS_CSV "eggs.csv"
#define ROTTEN_CSV "rotten_egg.csv" \


#line 1064 "examples.w"


#include "analysis.h"       
#include "fourier.h"     

#include <stdio.h> 
#include <stdlib.h> 
#ifdef HAVE_GETOPT
#ifdef HAVE_UNISTD_H
#include <unistd.h> 
#endif
#else
#include "getopt.h"     
#endif

/*:51*/
#line 966 "examples.w"
;

/*50:*/
#line 1040 "examples.w"

static void usage(void)
{
cout<<PRODUCT<<"  --  Analyse eggsummary files.  Call:\n";
cout<<"              "<<PRODUCT<<" [options] [infile] [outfile]\n";
cout<<"\n";
cout<<"Options:\n";
cout<<"           --copyright       Print copyright information\n";
cout<<"           -u, --help        Print this message\n";
cout<<"           --version         Print version number\n";
cout<<"\n";
cout<<"by John Walker\n";
cout<<"http://www.fourmilab.ch/\n";
}

/*:50*/
#line 968 "examples.w"
;

int main(int argc,char*argv[])
{
extern char*optarg;
extern int optind;

try{

/*49:*/
#line 1006 "examples.w"

int opt;

while((opt= getopt(argc,argv,"nu-:"))!=-1){
switch(opt){

case'u':
case'?':
usage();
return 0;

case'-':
switch(optarg[0]){
case'c':
cout<<"This program is in the public domain.\n";
return 0;

case'h':
usage();
return 0;

case'v':
cout<<PRODUCT<<" "<<VERSION<<"\n";
cout<<"Last revised: "<<REVDATE<<"\n";
cout<<"The latest version is always available\n";
cout<<"at http://www.fourmilab.ch/eggtools/eggshell\n";
return 0;
}
}
}

/*:49*/
#line 977 "examples.w"
;

/*:47*/
#line 637 "examples.w"
;
eggdatabases ed;
ed.set_local_defaults();
generic_eggsummary_cache<egganalysis> ec(&ed,ROTTEN_CSV,50,150);
egganalysis*esr= ec.get_by_date("2001-01-29");

/*:29*//*30:*/
#line 652 "examples.w"

egg_properties_database epd;
epd.loadFromCSV(EGGS_CSV);
vector<unsigned int> na_eggs,other_eggs;
for(int i= 0;i<epd.size();i++){
egg_properties*ep= epd[i];
if((ep->latitude>=25)&&(ep->latitude<=50)&&
(ep->longitude>=60)&&(ep->longitude<=135)){
na_eggs.push_back(ep->eggNumber);
}else{
other_eggs.push_back(ep->eggNumber);
}
}

/*:30*//*31:*/
#line 671 "examples.w"

egganalysis exg,exo;
esr->extract_eggs(&exg,na_eggs);
esr->extract_eggs(&exo,other_eggs);

/*:31*//*32:*/
#line 687 "examples.w"

systemtime kickoff("2001-01-29 02:00:00");

esr->write_deviation_plot("example-7a",
"SuperBowl 2001-01-29: Worldwide Eggs",
systemtime::SecondsPerHour,
systemtime::SecondsPerHour*-2,
"Hours from Kickoff",
-0.05,
kickoff
);
exg.write_deviation_plot("example-7b",
"SuperBowl 2001-01-29: North American Eggs",
systemtime::SecondsPerHour,
systemtime::SecondsPerHour*-2,
"Hours from Kickoff",
-0.05,
kickoff
);
exo.write_deviation_plot("example-7c",
"SuperBowl 2001-01-29: Eggs Outside North America",
systemtime::SecondsPerHour,
systemtime::SecondsPerHour*-2,
"Hours from Kickoff",
-0.05,
kickoff
);
/*48:*/
#line 983 "examples.w"

}catch(exception&e){
cout<<"Blooie!!!  Exception popped: "<<e.what()<<endl;
#ifndef CORE_DUMP
#ifdef STACK_TRACE
char s[160];
sprintf(s,"/bin/echo 'where\nq' >/tmp/gdbcmd ; gdb  -batch --command "
"/tmp/gdbcmd %s %d",argv[0],getpid());
system(s);
sleep(5);
#endif
throw;
#endif
}

return 0;
}


/*:48*/
#line 714 "examples.w"
;

/*:32*/
