/*33:*/
#line 697 "examples.w"

/*36:*/
#line 744 "examples.w"


/*40:*/
#line 841 "examples.w"


#include "config.h"         
#define REVDATE "3rd February 2002" \

#define EGGS_CSV "eggs.csv"
#define ROTTEN_CSV "rotten_egg.csv" \


#line 844 "examples.w"


#include "analysis.h"        

#include <stdio.h> 
#include <stdlib.h> 
#ifdef HAVE_GETOPT
#ifdef HAVE_UNISTD_H
#include <unistd.h> 
#endif
#else
#include "getopt.h"     
#endif

/*:40*/
#line 746 "examples.w"
;

/*39:*/
#line 820 "examples.w"

static void usage(void)
{
cout<<PRODUCT<<"  --  Analyse eggsummary files.  Call:\n";
cout<<"              "<<PRODUCT<<" [options] [infile] [outfile]\n";
cout<<"\n";
cout<<"Options:\n";
cout<<"           --copyright       Print copyright information\n";
cout<<"           -u, --help        Print this message\n";
cout<<"           --version         Print version number\n";
cout<<"\n";
cout<<"by John Walker\n";
cout<<"http://www.fourmilab.ch/\n";
}

/*:39*/
#line 748 "examples.w"
;

int main(int argc,char*argv[])
{
extern char*optarg;
extern int optind;

try{

/*38:*/
#line 786 "examples.w"

int opt;

while((opt= getopt(argc,argv,"nu-:"))!=-1){
switch(opt){

case'u':
case'?':
usage();
return 0;

case'-':
switch(optarg[0]){
case'c':
cout<<"This program is in the public domain.\n";
return 0;

case'h':
usage();
return 0;

case'v':
cout<<PRODUCT<<" "<<VERSION<<"\n";
cout<<"Last revised: "<<REVDATE<<"\n";
cout<<"The latest version is always available\n";
cout<<"at http://www.fourmilab.ch/eggtools/eggshell\n";
return 0;
}
}
}

/*:38*/
#line 757 "examples.w"
;

/*:36*/
#line 698 "examples.w"
;

eggdatabases ed;
ed.set_local_defaults();
generic_eggsummary_cache<egganalysis> ec(&ed,ROTTEN_CSV,50,150);
egganalysis ext;

systemtime refstart;
systemtime exstart,exend;

exstart.fromString("2001-04-20 13:00:00");
exend.fromString("2001-04-24 22:30:00");
ec.extract_time_range(&ext,exstart,exend);
ext.compute_per_egg_statistics();
ext.describe();
ext.write_per_egg_statistics_CSV("peregg.csv");
ext.write_deviation_plot("devtest",
"",
systemtime::SecondsPerHour,
systemtime::SecondsPerHour*8,
"",
0.05,
refstart
);

/*37:*/
#line 763 "examples.w"

}catch(exception&e){
cout<<"Blooie!!!  Exception popped: "<<e.what()<<endl;
#ifndef CORE_DUMP
#ifdef STACK_TRACE
char s[160];
sprintf(s,"/bin/echo 'where\nq' >/tmp/gdbcmd ; gdb  -batch --command "
"/tmp/gdbcmd %s %d",argv[0],getpid());
system(s);
sleep(5);
#endif
throw;
#endif
}

return 0;
}


/*:37*/
#line 723 "examples.w"
;

/*:33*/
