/*3:*/
#line 80 "timedate.w"


#ifndef TIMEDATE_HEADER_DEFINES
#define TIMEDATE_HEADER_DEFINES
#include <stdio.h> 
#include <math.h>        
#include <time.h> 
#include <assert.h> 

#include <string> 
#include <stdexcept> 
using namespace std;
/*6:*/
#line 117 "timedate.w"

class angle{
#define PI 3.14159265358979323846          

public:

static double Pi(void){
return PI;
}


static double Asec(double x){
return x/3600.0;
}


static double dtr(double d){
return d*(PI/180);
}


static double rtd(double r){
return r/(PI/180);
}


static double fixangle(double d){
return d-360.0*(floor(d/360.0));
}


static double fixangr(double r){
return r-(PI*2)*(floor(r/(PI*2)));
}


static double d_m_s_to_decimal(int d,int m,double s){
return d+(m/60.0)+(s/(60.0*60.0));
}


static string degrees_to_d_m_s(double a);
#undef PI
};

/*:6*//*8:*/
#line 209 "timedate.w"


class systemtime:protected angle{

private:
time_t t;

public:
static const int SecondsPerDay= 24*60*60,
SecondsPerHour= 60*60,
SecondsPerMinute= 60;

systemtime(time_t it= 0){
set_time(it);
}

systemtime(string dateTime){
fromString(dateTime);
}


time_t get_time(void){
return t;
}


void set_time(const time_t nt){
t= nt;
}


void now(void){
t= time(NULL);
}



time_t midnight(void){
return t-(t%SecondsPerDay);
}






void dayStep(int days){
t= ((t/SecondsPerDay)+days)*SecondsPerDay;
}


void nextDay(void){
dayStep(1);
}


void previousDay(void){
dayStep(-1);
}


void toUTC(int*year= NULL,int*month= NULL,int*mday= NULL,
int*hour= NULL,int*min= NULL,int*sec= NULL);


void fromUTC(int year= 1970,int month= 1,int mday= 1,
int hour= 0,int min= 0,int sec= 0);


string dateToString(void);


string timeToString(void);



void fromString(string s);


double toJulian(void);


void fromJulian(double jd);



int weekday(void){
return jwday(toJulian());
}



double siderealTime(void){
return gmst(toJulian());
}


static double utctoj(long year,int mon,int mday,
int hour= 0,int min= 0,int sec= 0);


static void jyear(double td,
int*yy= NULL,int*mm= NULL,int*dd= NULL);


static void jhms(double j,int*h= NULL,int*m= NULL,int*s= NULL);


static int jwday(double j){
return((int)(j+1.5))%7;
}


static double gmst(double jd);


static double meanObliquityOfEcliptic(double jd);


static void nutation(double jd,double*deltaPsi,double*deltaEpsilon);


static double equationTime(double jd);


static void sunpos(double jd,bool apparent,
double*ra,double*dec,double*rv,double*slong);


static void moon_and_sun(double pdate,double*phaseang,
double*pphase,double*mage,double*dist,
double*angdia,double*sudist,double*suangdia);


static double kepler(double m,double ecc);

static void moonphases(double sdate,double phases[5]);

protected:

static void store_if(int*p,const int v){
if(p!=NULL){
*p= v;
}
}


static void dstore_if(double*p,const double v){
if(p!=NULL){
*p= v;
}
}

static double meanphase(double sdate,double k);
static double truephase(double k,double phase);
};

/*:8*/
#line 92 "timedate.w"

#endif

/*:3*/
